igeo

## Class IGraphicObject

- java.lang.Object
- - igeo.IGraphicObject

- All Implemented Interfaces:
    IGraphicI, ISubobject

      public abstract class IGraphicObject
      extends java.lang.Object
      implements ISubobject, IGraphicI

  A subobject of IObject to draw the object on displays.
  Author:
    Satoru Sugihara

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `IColor` | `color`
    `static float` | `colorRange1f`
    `static int` | `colorRange1i`
    `static float` | `colorRange2f`
    `static int` | `colorRange2i`
    `static float` | `colorRange3f`
    `static int` | `colorRange3i`
    `static float` | `colorRange4f`
    `static int` | `colorRange4i`
    `IObject` | `parent`
    `boolean` | `update`
    `boolean` | `visible`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IGraphicObject(IObject p)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract void` | `draw(igeo.gui.IGraphics g)`
    `java.awt.Color` | `getAWTColor()`
    `IColor` | `getColor()`
    `static java.awt.Color` | `getColor(java.awt.Color c, float alpha)`
    `static java.awt.Color` | `getColor(java.awt.Color c, int alpha)`
    `static java.awt.Color` | `getColor(float fgray)`
    `static java.awt.Color` | `getColor(float fgray, float falpha)`
    `static java.awt.Color` | `getColor(float fr, float fg, float fb)`
    `static java.awt.Color` | `getColor(float fr, float fg, float fb, float fa)`
    `static java.awt.Color` | `getColor(int gray)`
    `static java.awt.Color` | `getColor(int gray, int alpha)`
    `static java.awt.Color` | `getColor(int r, int g, int b)`
    `static java.awt.Color` | `getColor(int r, int g, int b, int a)`
    `static java.awt.Color` | `getHSBColor(float h, float s, float b)`
    `static java.awt.Color` | `getHSBColor(float h, float s, float b, float a)`
    `float` | `getWeight()`
    `void` | `hide()`
    `abstract boolean` | `isDrawable(igeo.gui.IGraphicMode mode)`
    `boolean` | `isVisible()`
    `IObject` | `parent()` getting parent object
    `ISubobject` | `parent(IObject parent)` setting parent object
    `void` | `setAttribute(IAttribute attr)`
    `void` | `setColor(java.awt.Color c)`
    `void` | `setColor(java.awt.Color c, float alpha)`
    `void` | `setColor(java.awt.Color c, int alpha)`
    `void` | `setColor(float fgray)`
    `void` | `setColor(float fgray, float falpha)`
    `void` | `setColor(float fr, float fg, float fb)`
    `void` | `setColor(float fr, float fg, float fb, float fa)`
    `void` | `setColor(IColor c)`
    `void` | `setColor(IColor c, float alpha)`
    `void` | `setColor(IColor c, int alpha)`
    `void` | `setColor(int gray)`
    `void` | `setColor(int gray, int alpha)`
    `void` | `setColor(int r, int g, int b)`
    `void` | `setColor(int r, int g, int b, int a)`
    `void` | `setHSBColor(float h, float s, float b)`
    `void` | `setHSBColor(float h, float s, float b, float a)`
    `void` | `setVisible(boolean v)`
    `void` | `setWeight(float w)`
    `void` | `show()`
    `void` | `update()` updating graphic when geometry change.
    `boolean` | `visible()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### colorRange1i

          public static int colorRange1i

    - #### colorRange2i

          public static int colorRange2i

    - #### colorRange3i

          public static int colorRange3i

    - #### colorRange4i

          public static int colorRange4i

    - #### colorRange1f

          public static float colorRange1f

    - #### colorRange2f

          public static float colorRange2f

    - #### colorRange3f

          public static float colorRange3f

    - #### colorRange4f

          public static float colorRange4f

    - #### color

          public IColor color

    - #### visible

          public boolean visible

    - #### parent

          public IObject parent

    - #### update

          public boolean update

  - ### Constructor Detail

    - #### IGraphicObject

          public IGraphicObject(IObject p)

  - ### Method Detail

    - #### parent

          public IObject parent()

      Description copied from interface: `ISubobject`
      getting parent object
      Specified by:
        `parent` in interface `ISubobject`

    - #### parent

          public ISubobject parent(IObject parent)

      Description copied from interface: `ISubobject`
      setting parent object
      Specified by:
        `parent` in interface `ISubobject`

    - #### draw

          public abstract void draw(igeo.gui.IGraphics g)

      Specified by:
        `draw` in interface `IGraphicI`

    - #### isDrawable

          public abstract boolean isDrawable(igeo.gui.IGraphicMode mode)

      Specified by:
        `isDrawable` in interface `IGraphicI`

    - #### isVisible

          public boolean isVisible()

      Specified by:
        `isVisible` in interface `IGraphicI`

    - #### visible

          public boolean visible()

    - #### hide

          public void hide()

    - #### show

          public void show()

    - #### update

          public void update()

      updating graphic when geometry change. actual update happens when it's drawn.

    - #### setAttribute

          public void setAttribute(IAttribute attr)

    - #### setWeight

          public void setWeight(float w)

    - #### getWeight

          public float getWeight()

    - #### setVisible

          public void setVisible(boolean v)

    - #### setColor

          public void setColor(IColor c)

    - #### setColor

          public void setColor(java.awt.Color c)

    - #### getColor

          public IColor getColor()

    - #### getAWTColor

          public java.awt.Color getAWTColor()

    - #### setColor

          public void setColor(IColor c,
                      int alpha)

    - #### setColor

          public void setColor(IColor c,
                      float alpha)

    - #### setColor

          public void setColor(java.awt.Color c,
                      int alpha)

    - #### setColor

          public void setColor(java.awt.Color c,
                      float alpha)

    - #### setColor

          public void setColor(int gray)

    - #### setColor

          public void setColor(float fgray)

    - #### setColor

          public void setColor(int gray,
                      int alpha)

    - #### setColor

          public void setColor(float fgray,
                      float falpha)

    - #### setColor

          public void setColor(int r,
                      int g,
                      int b)

    - #### setColor

          public void setColor(float fr,
                      float fg,
                      float fb)

    - #### setColor

          public void setColor(int r,
                      int g,
                      int b,
                      int a)

    - #### setColor

          public void setColor(float fr,
                      float fg,
                      float fb,
                      float fa)

    - #### setHSBColor

          public void setHSBColor(float h,
                         float s,
                         float b,
                         float a)

    - #### setHSBColor

          public void setHSBColor(float h,
                         float s,
                         float b)

    - #### getColor

          public static java.awt.Color getColor(java.awt.Color c,
                                int alpha)

    - #### getColor

          public static java.awt.Color getColor(java.awt.Color c,
                                float alpha)

    - #### getColor

          public static java.awt.Color getColor(int gray)

    - #### getColor

          public static java.awt.Color getColor(float fgray)

    - #### getColor

          public static java.awt.Color getColor(int gray,
                                int alpha)

    - #### getColor

          public static java.awt.Color getColor(float fgray,
                                float falpha)

    - #### getColor

          public static java.awt.Color getColor(int r,
                                int g,
                                int b)

    - #### getColor

          public static java.awt.Color getColor(float fr,
                                float fg,
                                float fb)

    - #### getColor

          public static java.awt.Color getColor(int r,
                                int g,
                                int b,
                                int a)

    - #### getColor

          public static java.awt.Color getColor(float fr,
                                float fg,
                                float fb,
                                float fa)

    - #### getHSBColor

          public static java.awt.Color getHSBColor(float h,
                                   float s,
                                   float b,
                                   float a)

      Parameters:
        `h` - hue [0-1]
        `s` - saturation [0-1]
        `b` - brightness [0-1]
        `a` - alpha [0-1]

    - #### getHSBColor

          public static java.awt.Color getHSBColor(float h,
                                   float s,
                                   float b)

      Parameters:
        `h` - hue [0-1]
        `s` - saturation [0-1]
        `b` - brightness [0-1]